LM0
LISTING 2


*  Z.PRG
*
*  May 15, 1990
*
*  Demonstration program only.  Serves no useful purpose
*  other than to demonstrate the use of 'C' function calling
*  in a CLIPPER application.
*
*  ZFILL(string, replacement, ignore) will replace all characters
*  in STRING with REPLACEMENT except IGNOREd characters.
*
*  Placed in the public domain - NSA (No Strings Attached)

*  Escape key
escape_key = 27

*  Stay in demonstration loop until escape key
DO WHILE .T.
    CLEAR
    str         = "RANDOM CHARACTERS"
    replacement = "R"
    ignore      = "I"

    *  Paint the screen
    @ 04, 09 SAY "    PRESS ESCape key to terminate exercise . . ."
    @ 08, 09 SAY "      Enter character to ignore -> " GET ignore
    @ 10, 09 SAY "    Enter replacement character -> " GET replacement
    @ 12, 09 SAY "Enter string -> "                    GET str
    READ

    *  Exit on any escape key
    IF LASTKEY() = escape_key
       EXIT
       ENDIF

    error_temp = str

    *  Demonstrate results when invalid parameters passed
    *  (only two passed parameters equals an error!)
    error = ZFILL(error_temp, replacement)
    @ 14, 00 SAY "Invalid parameters returns -> " + STR(error,2)

    *  Execute function with valid parameters
    *  and hold returned value in ok_val
    ok_val = ZFILL(str, replacement, ignore)

    *  Display results
    *  NOTE: all 20 characters were tested, even trailing blanks.
    @ 16, 00 SAY "Number of characters replaced -> " + STR(ok_val,2)
    @ 18, 00 SAY "String after ZFILL() function -> " + str

    @ 23,00

    WAIT
    IF LASTKEY() = escape_key
       EXIT
       ENDIF
ENDDO

CLEAR
RETURN

**  END OF Z.PRG

