
LISTING 1


/*  ZFILL()  by J. W. Hart  July 15, 1990    */

/*  Syntax:  ZFILL( pachString, chReplacement_char, chIgnore_char )  */

/*  pachString is a (p)ointer to an (a)rray of (ch)ars  */
/*  riReplacement_count is a (r)egister (i)nt  */
/*  This type of coding can help avoid subtle ways of shooting y'self  */
/*  in the foot that can be extremely difficult to track down!!  */

#include  <nandef.h>
#include  <extend.h>

CLIPPER zfill()
{
char  *pachString, chReplacement_char, chIgnore_char;
register int  riChar_count, riReplacement_count = 0;
if  ( PCOUNT == 3  &&  ISCHAR(1)  &&  ISCHAR(2)  &&  ISCHAR(3) )
   {
   pachString = _parc(1);             /* assign address of string to pachString */
   chReplacement_char = *_parc(2);    /*  call _parc() only once  */
   chIgnore_char = *_parc(3);         /*  call _parc() only once  */
   for (riChar_count = 0; *pachString; riChar_count++) {
      if (*pachString != chIgnore_char)
         {
         *pachString = chReplacement_char;
         riReplacement_count++;
         }
      pachString++; }
   _retni( riReplacement_count );  /* Return number of replacements */
   }
else
   _retni( -1 );  /* return syntax error flag */
return;
}

END OF LISTING 2


