
Listing 2 for August TechTips



* Entry Conditions:
*	Work area contains DBF Indexed on KEYFIELD.
*       Code requires SET EXACT OFF.
*
* Returns: isrecord = .t. if record is found within range.
*          isrecord = .f. if record is not found.
*
* ' Define Range for values of Indexed FIELD 'KEYFIELD':
STORE 'PO   ' TO firstkey
STORE 'TZZZZ' TO lastkey
*
* ' Initialize and search.
SET EXACT OFF
STORE .f. TO isrecord
STORE ASC(firstkey) TO fkeyasc
STORE ASC(lastkey) TO lkeyasc
DO WHILE fkeyasc <= lkeyasc .AND. .NOT. isrecord
  SEEK CHR(fkeyasc)
  IF EOF()
    STORE fkeyasc + 1 TO fkeyasc
    LOOP
  ELSE
    COUNT WHILE Keyfield < firstkey
    IF Keyfield <= lastkey .AND. .NOT. EOF()
      STORE .t. TO isrecord   && record found within range.
    ENDIF
  ENDIF  && EOF()
ENDDO  && fkeyasc <= lkeyasc
* ' Reset EXACT as necessary.
* ' End-of-Example
